;==================================================================
;Project Title:      
;Author:          Spidy
;Email:           Spidy@i.ua
;Version:         1.0  
;Date:            26.01.2007
;==================================================================

Global ark_blur_image,ark_blur_texture,ark_sw,ark_sh,blur_power#,time_blur,blur; 
Global GfxDrv$,capable$,Caps3D$,fps,fr,frTime,dt#,to_dt#,time,muzic,camera,PC$,lite,rey,wire,fontsize,red#,green#,blue#; 
Global img_cur,img_font1,img_font2;
Global mesh_car;
Global sfx_menu;

R_Init(1024,768,16,0);  

While Not KeyHit(1)
		
    time = MilliSecs()
	UpdateWorld
	RenderWorld    
	UpdateGameEngine();   	
	DrawGameEngine();        
	    
   	fr = fr + 1
	If MilliSecs() - frTime >= 1000
		fps = fr
		fr = 0
		frTime = MilliSecs()
	EndIf
	
	Flip 1	
	to_dt# = (MilliSecs() - time) / 60.0
	dt# = dt# + (to_dt# - dt#) * .1
Wend
FreeEnd(); 
ShowPointer; 
End

Function R_Init(a,b,c,d)

    version$="1.0"; 
    muzic=1;  (1-,0-)
    blur=1;  (1-,0-)
    rey=255
	fontsize=16
    red#=60:green#=0:blue#=30;(RGB)	

    If GfxMode3DExists (a,b,c)
    Graphics3D a,b,c,d; 
    Else 
    RuntimeError "PC display resolutions error "+a+"x"+b+"x"+c 
    EndIf  

    AppTitle "Blitz game 3D ver "+version;    
    SetFont LoadFont("courier new cyr",18,1); 
	PC$=GetEnv$("PROCESSOR_ARCHITECTURE")

    For a = 1 To CountGfxDrivers (); 3D-
    If GfxDriver3D (a)
    GfxDrvName$=GfxDriverName (a)
    GfxDrv$= GfxDriverName (a)
    capable$=" is 3D-capable"
    Else
    capable$=" is NOT 3D-capable"
    EndIf
    Next

    caps=GfxDriverCaps3D();      
    Select caps
    Case 100 Caps3D$=" "
    Case 110 Caps3D$="" 
    End Select    
	
    Load_img(); 
    Load_sfx();  
    Load_mesh(); 

    camera=CreateCamera();        
    lite = CreateLight()
    RotateEntity lite,90,0,0		
    HidePointer; 

	ScaleEntity mesh_car,2,2,2
    PositionEntity mesh_car,150,0,0
	
	If muzic=1 Then LoopSound sfx_menu : PlaySound ( sfx_menu )
	
;------------------------------------- CREATE BLUR -------------------------------------------
    If blur=1 Then; -
    blur_power# = 0.5
    Cls
    SetBuffer BackBuffer()
    angle# = 0:dt# = 0.01:fr = 0:fps = 0
    frTime = MilliSecs()
    CreateBlurImage()
	EndIf
;---------------------------------------------------------------------------------------------

End Function

Function Load_img()

   img_cur=LoadImage("img\cur.bmp"):If img_cur=0 Then ProgramError "  : img\cur.bmp"

   img_font1=LoadImage("img\font_consirva.bmp")
   If img_font1=0 Then ProgramError "  : img\font_consirva.bmp"
   img_font2=LoadImage("img\font_old.bmp")
   If img_font2=0 Then ProgramError "  : img\font_old.bmp"
   
End Function

Function Load_mesh()

   mesh_car=LoadMesh("mesh\car.3ds"):If mesh_car=0 Then ProgramError "  : mesh\car.3ds"   
   ;mesh_f=LoadMesh("mesh\a_800.3DS"):If mesh_f=0 Then ProgramError "  : a_800.3DS"   
   
End Function

Function Load_sfx()

   sfx_menu=LoadSound("sfx\Wind.wav"):If sfx_menu=0 Then ProgramError "  : sfx\Wind.wav"   
   
End Function

Function UpdateGameEngine()
    If rey>0 Then rey=rey-1
	
    PointEntity camera,mesh_car	
    TurnEntity mesh_car,0,1,0

    If KeyDown(74) And blur=1 Then 
		blur_power# = blur_power# - dt# * .01
		If blur_power# < 0.5 Then blur_power# = 0.5		
	ElseIf KeyDown(78) And blur=1 Then
		blur_power# = blur_power# + dt# * .01
		If blur_power# > 0.9 Then blur_power# = 0.9		
	EndIf
    
	If KeyHit(57) wire=Not wire:WireFrame wire; 
	
    If KeyDown( 59 )=True And red#>0 Then red#=red#-1
    If KeyDown( 60 )=True And red#<255 Then red#=red#+1
    If KeyDown( 61 )=True And green#>0 Then green#=green#-1
    If KeyDown( 62 )=True And green#<255 Then green#=green#+1
    If KeyDown( 63 )=True And blue#>0 Then blue#=blue#-1
    If KeyDown( 64 )=True And blue#<255 Then blue#=blue#+1

    If KeyDown( 208 )=True And rey>0 Then rey=rey-5;(   )
    If KeyDown( 200 )=True And rey<255 Then rey=rey+5
	   
	If KeyDown(29);ctrl      
		SetGammaRed(rey)
	Else
		SetGammaIntensity(rey)
	EndIf	

	AmbientLight red#,green#,blue#; (F1-F6)
	If blur=1 Then UpdateBlur(blur_power# + (1.0 / (dt# * 120.0)));   -
	
End Function

Function DrawGameEngine()

    Color 255, 255, 50
    Text 5,0,"Video: " +GfxDrv$+capable$
	Text 5,20,"  " +Caps3D$
	Text 5,40,": " +TrisRendered()
	Text 5,60,"RGB: " +red#+" "+green#+" "+blue#
	
	Te_xt (800,0,"FPS : " + fps,1)
	Te_xt (800,20,"BLUR : " + Int(blur_power# * 100.0) / 100.0,1)
    Te_xt (800,40,": "+rey,2)
	Te_xt (800,60,"PROCESSOR: "+PC$,2)

	Te_xt (5,GraphicsHeight()-30," Ctrl,KeyUp,KeyDown,+,-,F1-F6,Space",2)
	DrawImage img_cur,MouseX(),MouseY(); 

End Function

Function SetGammaRed(n)
	For k=0 To 255
       SetGamma k,k,k,k+n,0,0
	Next
	UpdateGamma
End Function

Function SetGammaIntensity(n)
	For k=0 To 255
		SetGamma k,k,k,k+n,k+n,k+n
	Next
	UpdateGamma
End Function

Function Te_xt (x,y,s$,f)
   	
	g=x
    db=Len(s$)
    For i = 1 To db    
	  bukva$ = Mid$(s$, i, 1)
      tij = Asc(bukva$)+1; - 31
	      da=0:dx=0:dy=1
		  While da<tij
		    da=da+1:dx=dx+1
            If dx>16 Then dx=1:dy=dy+1
			Wend
	   g=g+(fontsize/1.4)
       If f=1 DrawImageRect img_font1,g,y,(dx*fontsize)-fontsize,(dy*fontsize)-fontsize,fontsize,fontsize,0
	   If f=2 DrawImageRect img_font2,g,y,(dx*fontsize)-fontsize,(dy*fontsize)-fontsize,fontsize,fontsize,0	   
	   Next	   
	
End Function

Function CreateBlurImage()
	;Create blur camera
	Local cam = CreateCamera()
	CameraClsMode cam, 0, 0
	CameraRange cam, 0.1, 1.5
	MoveEntity cam, 0, 0, 10000

	ark_sw = GraphicsWidth()
	ark_sh = GraphicsHeight()
		
	;Create sprite
	Local spr = CreateMesh(cam)
	Local sf = CreateSurface(spr)
	AddVertex sf, -1, 1, 0, 0, 0
	AddVertex sf, 1, 1, 0, 1, 0
	AddVertex sf, -1, -1, 0, 0, 1
	AddVertex sf, 1, -1, 0, 1, 1
	AddTriangle sf, 0, 1, 2
	AddTriangle sf, 3, 2, 1
	EntityFX spr, 17
	ScaleEntity spr, 1024.0 / Float(ark_sw), 1024.0 / Float(ark_sw), 1
	PositionEntity spr, 0, 0, 1.0001
	EntityOrder spr, -100000
	EntityBlend spr, 1
	ark_blur_image = spr
	
	;Create blur texture
	ark_blur_texture = CreateTexture(1024, 1024, 256)
	EntityTexture spr, ark_blur_texture
End Function

Function UpdateBlur(power#)
	EntityAlpha ark_blur_image, power#
	CopyRect  ark_sw / 2 - 512, ark_sh / 2 - 512, 1024, 1024, 0, 0, BackBuffer(), TextureBuffer(ark_blur_texture)	
End Function

Function ProgramError(s$)

	RuntimeError s$
	
End Function

Function FreeEnd()

    FreeImage img_cur
    FreeImage img_font1
    FreeImage img_font2
    FreeEntity mesh_car

End Function